// #autoload
// #name = HalBuddy
// #version = 2.6
// #date = June 8, 2002
// #author = Halide
// #warrior = Halide
// #email = halide@popmail.com
// #web = http://halides.tribes-universe.com/
// #description = Tracks buddies on servers, including their online status.
// #credit = Soterion, VeKToR - info on clan tags, PanamaJack - info on color codes, TwoChat script - gui for the 'Alias List'
// #category = Halide's Scripts

if(!isObject(HalBuddy))
{
	new ScriptObject(HalBuddy)
	{
		class = HalBuddy;
		version = "2.6";
		// prefs
		wavFile = "fx/misc/switch_taken.wav"; // Notify sound -- path relative to the gamedata/base/audio folder
		updateTime = 30; // Seconds between updates for online status -- recommended 30-120
		color[1] = "44ff44"; // Log on, connect
		color[2] = "ffff44"; // Join team
		color[3] = "ff4444"; // Log off, disconnect
	};
}

function HalBuddyToggle(%val)
{
	if(!%val)
		return;

	$HalPref::Buddy::Enabled = !$HalPref::Buddy::Enabled;

	alxPlay(sButtonOver, 0, 0, 0);

	if($HalPref::Buddy::Enabled)
		addMessageHudLine("\c2HalBuddy enabled.");
	else
		addMessageHudLine("\c2HalBuddy disabled.");
}

// START package HalBuddy
package	HalBuddy
{

	function HalBuddy::setPrefs(%this)
	{
		if(isFile("prefs/HalPrefs.cs") && !$HalPrefsLoaded)
		{
			exec("prefs/HalPrefs.cs");
			$HalPrefsLoaded = true;
		}

		if($HalPref::Buddy::Version $= "")
		{
			$HalPref::Buddy::Version = HalBuddy.version;
			$HalPref::Buddy::Enabled = true;
			$HalPref::Buddy::PlaySound = true;
			$HalPref::Buddy::Connect = true;
			$HalPref::Buddy::JoinTeam = true;
			$HalPref::Buddy::Disconnect = true;
			$HalPref::Buddy::LogOn = true;
			$HalPref::Buddy::LogOff = true;
			$HalPref::Buddy::Flash = 2.5;
			$HalPref::Buddy::Dock = true;
			$HalPref::Buddy::Trans = false;
		}
	}

	function HalBuddy::onDatabaseQueryResult(%this, %status, %resultString, %key)
	{
		switch$(%this.status)
		{
			case "buddyList":
				%this.buddyList = "";
				%this.IDstr = "";
				%this.buddyNum = 0;
			case "getOnline":
				if(getField(%status, 0) == 0)
				{
					for(%i = 1; %i <= %this.buddyNum; %i++)
					{
						%this.buddyOn[1, %i] = getSubStr(%resultString, %i, 1);

						if(!%this.updated)
							%this.buddyOn[0, %i] = %this.buddyOn[1, %i];
					}
				}
				%this.status = "done";
				%this.updated = true;
				%this.updateOnlineStatus();
		}
	}

	function HalBuddy::updateOnlineStatus(%this)
	{
		if(isEventPending(%this.updateSchedule))
			cancel(%this.updateSchedule);

		if($HalPref::Buddy::LogOn || $HalPref::Buddy::LogOff)
		{
			%this.alertDelay = 0;

			for(%i = 1; %i <= %this.buddyNum; %i++)
			{
				if(%this.buddyOn[0, %i] != %this.buddyOn[1, %i])
					%this.schedule(%this.alertDelay += 3000, onlineStatusChange, %this.buddyName[%i], %this.buddyOn[1, %i]);

				%this.buddyOn[0, %i] = %this.buddyOn[1, %i];
			}

			%this.getOnlineStatus();
		}

		%this.updateSchedule = %this.schedule(%this.updateTime * 1000, updateOnlineStatus);
	}

	function HalBuddy::onlineStatusChange(%this, %name, %on)
	{
		if(%on && $HalPref::Buddy::LogOn)
			%this.alert(%name SPC "<color:" @ %this.color[1] @ ">has logged on.");

		if(!%on && $HalPref::Buddy::LogOff)
			%this.alert(%name SPC "<color:" @ %this.color[3] @ ">has logged off.");
	}

	function HalBuddy::getOnlineStatus(%this)
	{
		%this.status = "getOnline";

		databaseQuery(69, %this.IDstr, %this, %this.key);
	}

	function HalBuddy::onDatabaseRow(%this, %row, %isLastRow, %key)
	{
		if(%this.status !$= "buddyList")
			return;

		%buddy = getField(%row, 0);
		%id = getField(%row, 3);
		%this.buddyList = %this.buddyList @ "\t" @ %buddy;
		%this.IDstr = %this.IDstr @ "\t" @ %id;
		%this.buddyNum++;
		%this.buddyName[%this.buddyNum] = %buddy;
		%this.buddyID[%this.buddyNum] = %id;

		if(%isLastRow)
			%this.getOnlineStatus();
	}

	function HalBuddyJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
	{
		if($HalPref::Buddy::Connect)
			HalBuddy.checkName(detag(%clientName), 1, "connected to the game.");
	}

	function HalBuddyJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
	{
		if($HalPref::Buddy::JoinTeam)
		{
			%teamName = detag(%teamName);

			if(%teamName $= "")
			{
				if(StrStr(%msgString, "fray") != -1)
					%tmp = "joined the fray.";
				else if(StrStr(%msgString, "hunt") != -1)
					%tmp = "joined the hunt.";
				else
					%tmp = "joined a team.";
			}
			else
			{
				if(%teamName $= "Unassigned" || %teamName $= "Spectator")
					%tmp = "has become an observer.";
				else
					%tmp = "joined team " @ %teamName @ ".";
			}

			HalBuddy.checkName(detag(%clientName), 2, %tmp);
		}
	}

	function HalBuddyDrop(%msgType, %msgString, %clientName, %clientId)
	{
		if($HalPref::Buddy::Disconnect)
			HalBuddy.CheckName(detag(%clientName), 3, "has left the game.");
	}

	function HalBuddy::checkName(%this, %name, %color, %msgString)
	{
		%name = %this.stripTag(%name);
		if(%name $= "")
			return;
		%msgString = %name @ " <color:" @ %this.color[%color] @ ">" @ %msgString;
		if((strStr(%this.buddyList, "\t" @ %name) != -1) || (strStr($HalPref::Buddy::AliasList, "\t" @ %name) != -1))
			%this.alert(%msgString);
	}

	function HalBuddy::stripTag(%this, %name)
	{
		%pos1 = strStr(%name, "\c7");
		if(%pos1 == -1)
		{
			if(strStr(%name, "\c6") != -1)
				%name = getSubStr(%name, 1, strLen(%name) - 1);
			if(strStr(%name, "\c8") != -1)
				%name = getSubStr(%name, 1, strLen(%name) - 2);
		}
		else
		{
			if(%pos1 == 1)
			{
				%pos2 = strStr(%name, "\c6");
				%name = getSubStr(%name, %pos2 + 1, strLen(%name) - %pos2 - 2);
			}
			else
				%name = getSubStr(%name, 2, %pos1 - 2);
		}
		return %name;
	}

	function HalBuddy::alert(%this, %msgString)
	{
		if(!(PlayGui.isAwake() && $HalPref::Buddy::Enabled))
			return;

		if($HalPref::Buddy::PlaySound)
			alxPlay(HalBuddySound, 0, 0, 0);

		if($HalPref::Buddy::Dock)
		{
			%xpos = getWord(objectiveHud.position, 0);
			%ypos = getWord(objectiveHud.position, 1) - 21;
			HalBuddyHud.position = %xpos SPC %ypos;
		}

		HalBuddyHudText.setValue("<just:center>" @ %msgString);

		if(!%this.flashing)
		{
			%this.flashing = true;
			%this.flashCount = mFormatFloat($HalPref::Buddy::Flash, "%.f") * 2 + 1;
			HalBuddyHud.visible = true;
			%this.flashHud();
		}
		else
			%this.extra = %this.extra++ > 3 ? 3 : %this.extra++;
	}

	function HalBuddy::flashHud(%this)
	{
		%this.flashCount--;

		if(%this.flashCount > 0)
		{
			HalBuddyHud.setVisible(!HalBuddyHud.visible);
			%this.schedule(200, flashHud);
		}
		else
			%this.schedule(4000, clearHud);
	}

	function HalBuddy::clearHud(%this)
	{
		if(%this.extra > 0)
		{
			%this.extra--;
			%this.schedule(2000, clearHud);
			return;
		}
		%this.flashing = false;
		HalBuddyHud.visible = false;
	}

	function HalBuddy::query(%this)
	{
		%this.status = "buddyList";
		DatabaseQueryArray(5, 0, getField($pref::Player[$pref::Player::Current], 0), %this, 0, true);
	}

	function LoadingGui::onWake(%this)
	{
		if(isObject(HM) && isObject(HudMover))
			hudmover::addhud(HalBuddyHud, "HalBuddy");

		HalBuddy.checkHM(false);

		if(!HalBuddy.updated)
			HalBuddy.query();

		parent::onWake(%this);
	}

	function DispatchLaunchMode()
	{
		HalBuddy.setup();

		addMessageCallback('MsgClientJoin', HalBuddyJoin);
		addMessageCallback('MsgClientJoinTeam', HalBuddyJoinTeam);
		addMessageCallback('MsgClientDrop', HalBuddyDrop);

		parent::DispatchLaunchMode();
	}

	function HalBuddy::setup(%this)
	{
		if(%this.setup)
			return;

		%this.setPrefs();

		new GuiControl(HalBuddyAddDlg) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellPaneCtrl() {
				profile = "ShellDlgPaneProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "242 184";
				extent = "156 112";
				minExtent = "48 92";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Add Alias";
				longTextBuffer = "0";
				maxLength = "255";
				noTitleBar = "0";

				new ShellTextEditCtrl(HalBuddyAliasEdit) {
					profile = "NewTextEditProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "16 26";
					extent = "124 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					longTextBuffer = "0";
					maxLength = "255";
					historySize = "0";
					password = "0";
					tabComplete = "0";
					deniedSound = "InputDeniedSound";
					glowOffset = "9 9";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "16 58";
					extent = "66 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "HalBuddyAliasList.addBuddy();";
					helpTag = "0";
					text = "OK";
					simpleStyle = "0";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "69 58";
					extent = "71 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "Canvas.popDialog(HalBuddyAddDlg);";
					helpTag = "0";
					text = "CANCEL";
					simpleStyle = "0";
				};
			};
		};

		new GuiControlProfile("HalBuddyTextArrayProfile")
		{
		   fontType = $ShellFont;
		   fontSize = $ShellFontSize;
		   fontColor   = "60 180 180";
		   fontColorHL = "6 245 215";
		   fontColorNA = "108 108 108";
		   fontColorSEL = "25 68 56";
		   bitmapBase = "gui/shll_bar";
		   tab = true;
		   canKeyFocus = true;
		};

		new GuiControl(HalBuddyPopup) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellPaneCtrl() {
				profile = "ShellDlgPaneProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "184 114";
				extent = "271 251";
				minExtent = "48 92";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "HalBuddy";
				longTextBuffer = "0";
				maxLength = "255";
				noTitleBar = "0";

				new GuiTextCtrl(HalBuddyFlashTxt) {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "66 160";
					extent = "58 20";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "Flash (2x)";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellSliderCtrl(HalBuddyFlashSlider) {
					profile = "ShellSliderProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "28 171";
					extent = "126 24";
					minExtent = "12 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "value";
					altCommand = "HalBuddyPopup.setFlash();";
					helpTag = "0";
					range = "1.000000 5.000000";
					ticks = "1000";
					value = "3";
					usePlusMinus = "1";
				};
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "19 158";
					extent = "144 39";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new GuiTextCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "46 32";
					extent = "96 20";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "- Alias Buddies -";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "19 29";
					extent = "144 129";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "165 198";
					extent = "89 32";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "167 196";
					extent = "83 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "Canvas.popDialog(HalBuddyPopup);";
					helpTag = "0";
					text = "DONE";
					simpleStyle = "0";
				};
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "19 198";
					extent = "145 32";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new ShellToggleButton(HalBuddyDockTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "21 201";
					extent = "55 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::Dock";
					helpTag = "0";
					text = "Dock";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton(HalBuddyTransTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "73 201";
					extent = "83 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::Trans";
					helpTag = "0";
					text = "Transparent";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new GuiTextCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "180 56";
					extent = "73 20";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "- Notify On -";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellScrollCtrl() {
					profile = "NewScrollCtrlProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "23 44";
					extent = "136 87";
					minExtent = "24 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					willFirstRespond = "1";
					hScrollBar = "alwaysOff";
					vScrollBar = "alwaysOn";
					constantThumbHeight = "0";
					defaultLineHeight = "15";
					childMargin = "3 3";
					fieldBase = "gui/shll_field";

					new GuiScrollContentCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "7 7";
						extent = "106 73";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						helpTag = "0";

						new ShellTextList(HalBuddyAliasList) {
							profile = "HalBuddyTextArrayProfile";
							horizSizing = "right";
							vertSizing = "bottom";
							position = "0 0";
							extent = "106 8";
							minExtent = "8 8";
							visible = "1";
							hideCursor = "0";
							bypassHideCursor = "0";
							helpTag = "0";
							enumerate = "0";
							resizeCell = "1";
							columns = "0";
							fitParentWidth = "1";
							clipColumnText = "0";
								ids = "0";
						};
					};
				};
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "164 29";
					extent = "89 168";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new ShellToggleButton(HalBuddyConnectTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "166 69";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::Connect";
					helpTag = "0";
					text = "Connect";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton(HalBuddyJoinTeamTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "166 94";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::JoinTeam";
					helpTag = "0";
					text = "Join Team";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton(HalBuddyDisconnectTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "166 119";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::Disconnect";
					helpTag = "0";
					text = "Disconnect";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "18 124";
					extent = "65 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "Canvas.pushDialog(HalBuddyAddDlg);";
					helpTag = "0";
					text = "ADD";
					simpleStyle = "0";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "71 124";
					extent = "94 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "HalBuddyAliasList.removeSelected();";
					helpTag = "0";
					text = "DEL SELECTED";
					simpleStyle = "0";
				};
				new ShellToggleButton(HalBuddyPlaySoundTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "167 31";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::PlaySound";
					helpTag = "0";
					text = "Play Sound";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton(HalBuddyLogOnTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "166 144";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::LogOn";
					helpTag = "0";
					text = "Log-On";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton(HalBuddyLogOffTgl) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "166 169";
					extent = "80 27";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$HalPref::Buddy::LogOff";
					helpTag = "0";
					text = "Log-Off";
					longTextBuffer = "0";
					maxLength = "255";
				};
			};
		};

		new GuiControlProfile("HalBuddyTextProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 18;
			fontColor = "220 240 255";
			justify = "center";
		};

		new GuiControl(HalBuddyHud)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "245 20";
			minExtent = "8 8";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFieldCtrl(HalBuddyHudBack) {
				profile = "GuiChatBackProfile";
				horizSizing = "center";
				vertSizing = "top";
				position = "0 0";
				extent = "245 20";
				minExtent = "8 8";
				visible = "0";
				helpTag = "0";
			};
			new GuiMLTextCtrl(HalBuddyHudText) {
				profile = "HalBuddyTextProfile";
				horizSizing = "center";
				vertSizing = "top";
				position = "0 0";
				extent = "245 20";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "0";
				allowColorChars = "0";
				maxChars = "-1";
			};
		};

		HalBuddyHudBack.setVisible(!$HalPref::Buddy::Trans);

		PlayGui.add(HalBuddyHud);

		new AudioProfile(HalBuddySound)
		{
			filename = %this.wavFile;
			description = "audioGui";
			preload = true;
		};

		HalBuddyPlaySoundTgl.setValue($HalPref::Buddy::PlaySound);
		HalBuddyConnectTgl.setValue($HalPref::Buddy::Connect);
		HalBuddyJoinTeamTgl.setValue($HalPref::Buddy::JoinTeam);
		HalBuddyDisconnectTgl.setValue($HalPref::Buddy::Disconnect);
		HalBuddyLogOnTgl.setValue($HalPref::Buddy::LogOn);
		HalBuddyLogOffTgl.setValue($HalPref::Buddy::LogOff);
		HalBuddyFlashSlider.setValue($HalPref::Buddy::Flash);
		HalBuddyDockTgl.setValue($HalPref::Buddy::Dock);
		HalBuddyTransTgl.setValue($HalPref::Buddy::Trans);

		%this.setup = true;
	}

	function HalBuddyPopup::setFlash(%this)
	{
		$HalPref::Buddy::Flash = (%flash = mFormatFloat(HalBuddyFlashSlider.getValue(), "%.f"));
		HalBuddyFlashTxt.setValue("Flash (" @ %flash @ "x)");
	}

	function HalBuddyTransTgl::onAction(%this)
	{
		HalBuddyHudBack.setVisible(!%this.getValue());
	}

	function HalBuddyPopup::onWake(%this)
	{
		clientCmdTogglePlayHuds(false);

		HalBuddyAliasList.ids = 0;
		HalBuddyAliasList.update();
	}

	function HalBuddyPopup::onSleep(%this)
	{
		clientCmdTogglePlayHuds(true);
	}

	function HalBuddyPopupToggle(%val)
	{
		if(!%val)
			return;

		if(HalBuddyPopup.isAwake())
			Canvas.popDialog(HalBuddyPopup);
		else
			Canvas.pushDialog(HalBuddyPopup);
	}

	function HalBuddy::checkHM(%this, %save)
	{
		if(isObject(HM) && isObject(HudMover))
		{
			if($HalPref::Buddy::Dock)
			{
				$hudPos[HalBuddyHud] = "";

				if(%save)
					hudmover::savepos($hudmover::currentmap);
			}
		}
	}

	function HalBuddyDockTgl::onAction(%this)
	{
		HalBuddy.checkHM(true);
	}

	function HalBuddyAliasList::rebuildBuddyList(%this)
	{
		$HalPref::Buddy::AliasList = "";
		for(%i = 0; %i < %this.rowCount(); %i++)
			$HalPref::Buddy::AliasList = $HalPref::Buddy::AliasList @ "\t" @ %this.getRowText(%i);
	}

	function HalBuddyAliasList::removeSelected(%this)
	{
		%id = %this.getSelectedId();

		if(%id != -1)
		{
			%this.removeRowById(%id);
			%this.rebuildBuddyList();
		}
	}

	function HalBuddyAliasList::addBuddy(%this)
	{
		Canvas.popDialog(HalBuddyAddDlg);
		%name = trim(HalBuddyAliasEdit.getValue());
		if(%name $= "")
			return;
		else
			HalBuddyAliasEdit.setValue("");
		%this.addRow(%this.ids, "\c8" @ %name);
		%this.ids++;
		%this.rebuildBuddyList();
	}

	function HalBuddyAliasList::update(%this)
	{
		%this.clear();

		%tmp = nextToken($HalPref::Buddy::AliasList, buddy, "\t");
		while(%buddy !$= "")
		{
			%this.addRow(%this.ids, %buddy);
			%this.ids++;
			%tmp = nextToken(%tmp, buddy, "\t");
		}

		%this.sort(0);
	}

	function OptionsDlg::onWake(%this)
	{
		if(!HalBuddy.bind)
		{
			$RemapName[$RemapCount] = "HalBuddy Toggle";
			$RemapCmd[$RemapCount] = "HalBuddyToggle";
			$RemapCount++;
			$RemapName[$RemapCount] = "HalBuddy Options";
			$RemapCmd[$RemapCount] = "HalBuddyPopupToggle";
			$RemapCount++;

			HalBuddy.bind = true;
		}

		parent::onWake(%this);
	}

	function quit()
	{
		if(!$HalPrefsSaved)
		{
			export("$HalPref::*", "prefs/HalPrefs.cs", false);
			$HalPrefsSaved = true;
		}

		parent::quit();
	}

// END package HalBuddy
};
activatePackage(HalBuddy);